import sys # system functions
import re # regular expression library
import csv # command separated value reader & writer

pattern = \
r'(\d{5})\s+(\w+)\s+(\d+)\s+(\w+)\s+(\d+)\s+(\d+[A-Z]?)\s+(.*)\n([^\n]+)([^:]*\n)+(\d\d:[^\n]+)\n+Type:\s+(\w+)\s+Building:\s+(.*)Room:\s+(\w+).*\n'
# https://pythex.org/
# https://docs.python.org/3/library/re.html

usage = "USAGE: python CSC458sp24Assn4.py FILEPREFIX"

if __name__ == '__main__':
    if len(sys.argv) != 2:
       raise ValueError(usage)
    filePrefix = sys.argv[1]
    infileName = filePrefix + '.txt'
    infile = open(infileName, 'r') 
    inlines = infile.readlines() 
    infile.close() 
    outfilename = filePrefix + 'Parsed.txt'
    csvfilename = filePrefix + '.csv'
    bigline = ''   
    for line in inlines:
        bigline += line  
    compiledre = re.compile(pattern)
    outfile = open(outfilename, 'w', newline='') 
    csvfile = open(csvfilename, 'w', newline='')
    csvwrt = csv.writer(csvfile, delimiter=',', quotechar='"') 
    csvwrt.writerow(
       ['id', 'semester', 'year', 'dept', 'number', 'section', 'title',
           'days', 'time', 'format', 'bldg', 'room',
           'tail']) 
    nextmatch = compiledre.search(bigline)
    while nextmatch:
        endchar = nextmatch.span(0)[1] 
        nextnextmatch = compiledre.search(bigline, endchar)
        if nextnextmatch:
            beyondchar = nextnextmatch.span(0)[0] 
            recordstring = bigline[nextmatch.span(0)[0]:beyondchar]
        else: 
            recordstring = bigline[nextmatch.span(0)[0]:] 
            beyondchar = len(bigline)
        myg = 13
        while nextmatch.group(myg).strip() == 'None':
            myg -= 1
        pastprep = False 
        remain = nextmatch.span(myg)[1] 
        linesleft = bigline[remain:beyondchar].split('\n') 
        tail = ''
        PrepCount = 0
        for l in linesleft:
            if ('Prep' in l):
                PrepCount = PrepCount + 1
        for l in linesleft:
            if ('Date' in l):
                continue 
            elif ('Prep' in l):
                PrepCount -= 1
                if PrepCount < 1:
                    pastprep = True
                continue
            else:
                ll = l.strip() 
                if ll and not ll in ('S', 'M', 'T', 'W', 'F'):
                    
                    tail = tail + '\t' + ll + '\n'
                    if pastprep:
                        break 
        csvrow = []
        outfile.write('**********\n') 
        for gr in range(1, 14): 
            if gr == 9:
                continue 
            csvrow.append(nextmatch.group(gr).strip())
            outfile.write(nextmatch.group(gr).strip() + ' ')
            if gr == 7:
                outfile.write('\n')
        outfile.write('\n')
        csvrow.append(tail.replace('\n',' ').replace(
            '\t',' ').replace(',',' '))
        if tail:
            outfile.write(tail)
        csvwrt.writerow(csvrow)
        nextmatch = nextnextmatch
    outfile.close()
    csvfile.close()
